﻿using C1.Win.C1Document;
using C1.Win.FlexReport;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Imaging;
using System.Drawing.Printing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace PrintAlternatePages
{
    public partial class Form1 : Form
    {
        C1FlexReport _flexEven = new C1FlexReport();
        C1FlexReport _flexOdd = new C1FlexReport();
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            c1FlexReport1.Load(@"..\..\Report.flxr", "Products Report");          
            c1FlexReport1.Render();
            c1FlexViewer1.DocumentSource = c1FlexReport1;

        }

        private void btnPrint_Click(object sender, EventArgs e)
        {          
            
            _flexEven.Layout.MarginBottom = 0;
            _flexEven.Layout.MarginLeft = 0;
            _flexEven.Layout.MarginRight = 0;
            _flexEven.Layout.MarginTop = 0;
            _flexEven.Sections.Header.Visible = false;
            _flexEven.Sections.Footer.Visible = false;
            _flexEven.Sections.PageHeader.Visible = false;
            _flexEven.Sections.PageFooter.Visible = false;
            _flexEven.Sections.Detail.Visible = true;
            _flexEven.Sections.Detail.AutoHeight = AutoSizeBehavior.CanGrow;
            _flexEven.Sections.Detail.SplitBehavior = SplitBehavior.SplitIfNeeded;
            _flexEven.Sections.Detail.SubSections[0].Height = (c1FlexReport1.Layout.PageSize.Height * ((int)(c1FlexReport1.PageCount - 1) / 2)) - ((c1FlexReport1.Layout.MarginTop + c1FlexReport1.Layout.MarginBottom)* ((int)(c1FlexReport1.PageCount - 1) / 2));
            _flexEven.Sections.Detail.SubSections[0].SplitBehavior = SplitBehavior.SplitIfNeeded;
           
            
            _flexOdd.Layout.MarginBottom = 0;
            _flexOdd.Layout.MarginLeft = 0;
            _flexOdd.Layout.MarginRight = 0;
            _flexOdd.Layout.MarginTop = 0;
            _flexOdd.Sections.Header.Visible = false;
            _flexOdd.Sections.Footer.Visible = false;
            _flexOdd.Sections.PageHeader.Visible = false;
            _flexOdd.Sections.PageFooter.Visible = false;
            _flexOdd.Sections.Detail.Visible = true;
            _flexOdd.Sections.Detail.AutoHeight = AutoSizeBehavior.CanGrow;
            _flexOdd.Sections.Detail.SplitBehavior = SplitBehavior.SplitIfNeeded;
            _flexOdd.Sections.Detail.SubSections[0].Height = (c1FlexReport1.Layout.PageSize.Height * ((int)((c1FlexReport1.PageCount)%2==0? (c1FlexReport1.PageCount - 1)/2: (c1FlexReport1.PageCount - 2) / 2))) - ((c1FlexReport1.Layout.MarginTop + c1FlexReport1.Layout.MarginBottom) * ((int)((c1FlexReport1.PageCount) % 2 == 0 ? (c1FlexReport1.PageCount - 1)/2 : (c1FlexReport1.PageCount - 2) / 2)));
            _flexOdd.Sections.Detail.SubSections[0].SplitBehavior = SplitBehavior.SplitIfNeeded;
           

            double _preTopEven = 0.0;
            double _preTopOdd = 0.0;
            for (int i = 0; i < c1FlexReport1.PageCount; i++)
            {
                if (i % 2 == 0)
                {

                    
                    ImageField im = new ImageField();
                    im.AutoHeight = AutoSizeBehavior.CanGrow;
                    im.AutoWidth = AutoSizeBehavior.CanGrow;
                    Metafile mf = c1FlexReport1.GetPageImage(i);
                    im.Picture = mf;
                    im.SplitVertBehavior = SplitBehavior.Never;
                    im.SplitHorzBehavior = SplitBehavior.Never;
                    im.Top = _preTopEven;
                    _preTopEven += _flexEven.Layout.PageSize.Height;
                    _flexEven.Sections.Detail.Fields.Add(im);  
                }
                else
                {

                    ImageField im = new ImageField();
                    im.AutoHeight = AutoSizeBehavior.CanGrow;
                    im.AutoWidth = AutoSizeBehavior.CanGrow;
                    Metafile mf = c1FlexReport1.GetPageImage(i);
                    im.Picture = mf;
                    im.SplitVertBehavior = SplitBehavior.Never;
                    im.SplitHorzBehavior = SplitBehavior.Never;
                    im.Top = _preTopOdd;
                    _preTopOdd += _flexOdd.Layout.PageSize.Height;                    
                    _flexOdd.Sections.Detail.Fields.Add(im);
                }
            }
            _flexEven.GenerateAsync().ContinueWith(t =>
            {
                PrinterSettings ps1 = new PrinterSettings();
                ps1.PrinterName = "Printer 1";
                ps1.PrintFileName = "file1";
                _flexEven.Print(ps1);
            });

            if (c1FlexReport1.PageCount > 1)
            {
                _flexOdd.GenerateAsync().ContinueWith(t =>
                {
                    PrinterSettings ps2 = new PrinterSettings();
                    ps2.PrinterName = "Printer 2";
                    ps2.PrintFileName = "file2";
                    _flexOdd.Print(ps2);
                });
            }


        }
    }
}
